package com.nisum.servicea.controller;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.WebMvcTest;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.MvcResult;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

@WebMvcTest(MessageRestController.class)
class MessageRestControllerTest {

    @Autowired
    MockMvc mockMvc;

    @Test
    void getMessage1_returnsValueFromServiceAConfig() throws Exception {
        MvcResult result = mockMvc.perform(MockMvcRequestBuilders.get("/message1"))
                .andExpect(status().isOk())
                .andReturn();
        assertEquals("Message1 from Service A cloud config file", result.getResponse().getContentAsString());
    }

    @Test
    void getMessage2_returnsValueFromGlobalCloudConfig() throws Exception {
        MvcResult result = mockMvc.perform(MockMvcRequestBuilders.get("/message2"))
                .andExpect(status().isOk())
                .andReturn();
        assertEquals("Message2 from global config file for all services", result.getResponse().getContentAsString());
    }

    @Test
    void getMessage3_returnsValueFromController() throws Exception {
        MvcResult result = mockMvc.perform(MockMvcRequestBuilders.get("/message3"))
                .andExpect(status().isOk())
                .andReturn();
        assertEquals("Default Message3 from controller", result.getResponse().getContentAsString());
    }
}